'use strict';

var expect = require('chai').expect,
    Int64 = require('node-int64'),
    M = require('../../lib/types/message');

describe('MessageTypes', function() {
  describe('Properties', function() {
    it('should encode user-id properly', function() {
      var props = new M.Properties({ userId: new Buffer(123) });
      expect(props.userId, 'From Buffer').to.be.an.instanceof(Buffer);

      props = new M.Properties({ userId: 123 });
      expect(props.userId, 'From int').to.be.an.instanceof(Buffer);

      props = new M.Properties({ userId: "123" });
      expect(props.userId, 'From string').to.be.an.instanceof(Buffer);

      props = new M.Properties({ userId: new Int64(12, 34)});
      expect(props.userId, 'From int64').to.be.an.instanceof(Buffer);
    });
  });
});
